/* Function converted CYRCLE APT command to C2/G3 or more G1 commands in
         milling mode*/
void circle_process_mill(double B,
                         double coord_x,  double coord_y,   double coord_z, 
                         double Center_x, double Center_y,  double Center_z, 
                         double Normal_x, double Normal_y,  double Normal_z, 
                         double End_x,    double End_y,     double End_z,
                         double radius,   double tolerance, double ratio, double angle)
{
   char COMMAND[4];
   char s_out[256];
   double Ex,Ey,Ez, Cx,Cy,Cz, Bx,By,Bz;
   double Lx,Ly,Lz, Mx,My,Mz, Nx,Ny,Nz;
   double Len;
   double FI,Rmin,Rmax,df;
   double xl,yl,zl,xt,yt,zt;
   double scalqr,rt;
   int steps,i,dir;	

   Bx = coord_x; By = coord_y; Bz = coord_z;
   Cx = Center_x; Cy = Center_y; Cz = Center_z;
   Ex = End_x; Ey = End_y; Ez = End_z;
   Nx = Normal_x; Ny = Normal_y; Nz = Normal_z;

	/* --> 1. Calculation of local system coordinat */
 
   Lx=Bx-Cx; 
   Ly=By-Cy; 
   Lz=Bz-Cz;
   Len=sqrt(Lx*Lx+Ly*Ly+Lz*Lz);
   Lx=Lx/Len; 
   Ly=Ly/Len; 
   Lz=Lz/Len;
   Mx=Ny*Lz-Nz*Ly; 
   My=Nz*Lx-Nx*Lz; 
   Mz=Nx*Ly-Ny*Lx;  /* M= N x L */

	/* can we save the circle interpolation */

   strcpy(COMMAND,"");
   if(B==0.0 || B==90.0 || B==-90.0)
   {	
      if(fabs(fabs(Nz) - 1.00) < 0.00001)	/* The circle in XY plane */
      { 
         if(Nz > 0.0 && type_of_goto != 2)  
         { 
            strcpy(COMMAND," G2"); 
            type_of_goto=2; 
            dir= 1;
         }
         else if(Nz < 0.0 && type_of_goto !=3 )  
         { 
            strcpy(COMMAND," G3"); 
            type_of_goto=3;	
            dir=-1;
         }
         if(plane_of_circle != 1) 
         {   
            plane_of_circle  = 1; 
            PTP(" G16 Y1= Z1= E1= Z1="); 
         }
         sprintf(s_out, "%s Y1=%.3lf Z1=%.3lf J%.3lf K%.3lf",
                          COMMAND, Ey, Ex, Cy-By, Cx-Bx);
      }
      else if( fabs(fabs(Ny)-1.00) < 0.00001)	/* The circle in XZ plane */
      { 
   	     if(Ny > 0.0 && type_of_goto != 2)  
         { 
            strcpy(COMMAND," G2"); 
            type_of_goto=2; 
            dir= 1; 
         }
         else if(Ny < 0.0 && type_of_goto != 3)  
         { 
            strcpy(COMMAND," G3"); 
            type_of_goto=3;	
            dir=-1;
         }
		 if(plane_of_circle != 3) 
         {   
            plane_of_circle  = 3; 
            PTP(" G16 Z1= E1= E1= Z1="); 
         }
         sprintf(s_out, "%s E1=%.3lf Z1=%.3lf I%.3lf K%.3lf",
                         COMMAND, Ez, Ex, Cz-Bz, Cx-Bx);
      }
      else if(fabs(fabs(Nx) - 1.00) < 0.00001)	/* The circle in YZ plane */ 
      { 
         if(Nx > 0.0 && type_of_goto != 2)  
         { 
            strcpy(COMMAND," G2"); 
            type_of_goto=2; 
            dir= 1;
         }
         else if(Nx < 0.0 && type_of_goto != 3)  
         { 
            strcpy(COMMAND," G3"); 
            type_of_goto=3;	
            dir=-1;
         }
		 if (plane_of_circle != 2)	
         {   
            plane_of_circle  = 2; 
            PTP(" G16 E1= Y1= E1= Z1="); 
         }
         sprintf(s_out, "%s E1=%.3lf Y1=%.3lf I%.3lf J%.3lf",
                         COMMAND, Ez, Ey, Cz-Bz, Cy-By);
      }
      else PTP(" ERROR coordinat B=0 or 90 or -90 and circle are not one of the mains plane");
      PTP(add_cls(add_feedrate(s_out),nc_block_in));
   }
   else				/* Linear interpolation:
	           The method of Local System calculation gurunties 
               that the positive rotation from begining to end point! */
   {
      dir=1;
      PTP(" ERROR you have a linear intepolation of circle");
      PTP("       in case of uniting circle it will produce wrong NC programm");

      Bx=Bx-Cx; By=By-Cy; Bz=Bz-Cz; Ex=Ex-Cx; Ey=Ey-Cy; Ez=Ez-Cz;	/* Step calculation */
      
      FI=angle;
      Rmin=radius-tolerance*ratio;  Rmax=radius+tolerance*(1-ratio);
      df=2*acos(Rmin/Rmax); steps=(int)(FI/df+0.5)+1; /* +1 step for sure  */
      df=FI/steps; 

      zl=0.0;
      strcpy(COMMAND," G1");
      for(i = 1; i <= steps; i++)
      {
         if(i == steps)	
         { 
            xt=End_x; yt=End_y; zt=End_z;
         }
         else
         {		
            FI=i*df*dir;
            xl=Rmax*cos(FI); yl=Rmax*sin(FI); /* Local coordinat systems */ 
            xt=Lx*xl+Mx*yl+Nx*zl;	         /* Return to 3D coordiant system */
            yt=Ly*xl+My*yl+Ny*zl;
            zt=Lz*xl+Mz*yl+Nz*zl;	
            
            /* Check scalqr */
            Len=sqrt(xt*xt+yt*yt+zt*zt);
		    scalqr=((xt/Len)*Nx+(yt/Len)*Ny+(zt/Len)*Nz);															   
            if(fabs(scalqr) > 0.001) 
      	    {
      		   sprintf(s_out," ERROR point are not circle scalqr=%lf\n", scalqr);
			   PTP(s_out);
            }
            xt=xt+Cx; yt=yt+Cy; zt=zt+Cz;
            rt=sqrt((xt-Cx)*(xt-Cx)+(yt-Cy)*(yt-Cy)+(zt-Cz)*(zt-Cz));
       		if(fabs(rt-Rmax) > 0.001  && fabs(rt-radius)>0.001)  
            {
               sprintf(s_out," ERROR point are not circle radius=%lf rt=%lf\n", rt,radius);
			   PTP(s_out);
            }
         }
         sprintf (s_out,"%s E1=%.3lf Y1=%.3lf Z1=%.3lf",COMMAND, zt,yt,xt);
         PTP(add_cls(add_feedrate(s_out),nc_block_in));
         if (i==1) strcpy(COMMAND,"");
      }
   }
}
