void cycle_process(int chanel_in, double b_old,
                   double *x_old, double *y_old, double *z_old, 
                   double *i_old, double *j_old, double *k_old)

{

   char *s1,*s2, s_c[20], s_y[20], COMMAND[4];
    
   char *rapto     = "RAPTO",      s_rapto[20],	  *c_rapto  =" R2=";
   char *fedto     = "FEDTO",      s_fedto[20],   *c_fedto  =" R3=";
   char *rtrcto    = "RTRCTO",     s_rtrcto[20],  *c_rtrcto =" R8=";
   char *mmpm      = "MMPM",       s_feed [20],   *c_feed   =" R9=";  
   char                            s_ffeed[20],   *c_ffeed  =" F";
   char *dwell     = "DWELL",      s_dwell[20],   *c_dwell  =" R4=";
   char *nodrag    = "NODRAG",     s_nodrag[20],  *c_nodrag =" R13=";
   char *mmpr      = "MMPR"; 
   char *drill     = "DRILL";
   char *csink     = "CSINK";
   char *cskdia    = "CSKDIA";
   char *tlangl    = "TLANGL";
   char *holdia    = "HOLDIA";
   char *tap       = "TAP";
   char *clw       = "CLW";
   char *cclw      = "CCLW";
   char *bore      = "BORE";
   char *drag      = "DRAG";
   char *back      = "BACK";	 
   char *deep      = "DEEP";
   char *brkchp    = "BRKCHP";
   char *step      = "STEP";
   char *option    = "OPTION";
   char *m_goto    = "GOTO/";
   char *cycle_off = "CYCLE/OFF";
   char *cam       = "CAM",        s_cam[20],      *c_cam=" R7=";
   char                            s_dwesta[20],   *c_dwesta=" R0=" ;
   char 	 					   s_dirrot[20],   *c_dirrot=" R7=" ;/* default for l74 */
   char                            s_revrot[20],   *c_revrot=" R6=" ;/* default for l74 */
   char *cycle_on  = "CYCLE/",     s_step1[20], s_step2[20], *c_step1=" R1=", *c_step2=" R5=";
   char                            s_x[20],        *c_x=" R12=";
   char                            s_z[20],  	   *c_z=" R11=";
 
   double d_rapto=0.0;
   double d_fedto=0.0;
   double d_rtrcto=0.0;
   double d_feed=0.0; 
   double d_feed_old=0.0;
   double d_dwell=0.0;
   double d_cskdia=0.0;
   double d_tlangl=90.0;
   double d_nodrag=0.0; 
   double d_holdia=0.0;
   double d_step1=0.0;
   double d_step2=0.0;
   double d_cam=0.0;
   double d_dwesta=0.0;
   double d_dirrot=3.0;
   double d_revrot=4.0;
   double x_option=0.0;
   double y_option=0.0;
   double z_option=0.0;
   double x_option_old = -999999.99;
   double y_option_old = -999999.99;
   double z_option_old = -999999.99;
   double x, y, z, i_int, j_int, k_int;
   double c_old = -999999.99;
   double x_old_cycle = -999999.99; 
   double z_old_cycle = -999999.99;
   double Cr,C,Len;

   int i_rapto=1;
   int i_fedto=1;
   int i_rtrcto=1;
   int i_feed=1; 
   int i_dwell=1;
   int i_cskdia=1;
   int i_tlangl=1;
   int i_nodrag=1; 
   int i_holdia=1;
   int i_step1=1;
   int i_step2=1;
   int i_cam=1;
   int i_dirrot=1;
   int i_revrot=1;
   int i_dwesta=1;
   int i_option=0;
   int irc, ret_num, in;
   int i_drill=0;
   int i_csink=0;
   int i_deep=0;
   int i_brkchp=0;
   int i_tap=0;
   int i_bore=0;
   int i_drag=0;
   int i_no_drag=0;
   int i_l74=0;
   int i_l78=0;

   char menu_list_1[2][38]={"Using L74 cycle", "Using L78 cycle"};
   char *mess1="Select type thread cycle L74 or L78";
   char *mess2="Select type of thread";
   char menu_list_2[2][38]={"Right-hand thread", "Left-hand thread"};

/* define type of CYCLE */
   if(strstr(nc_block_in,drill) != NULL) i_drill = 1;
   if(strstr(nc_block_in,csink) != NULL) i_csink = 1;
   if(strstr(nc_block_in,deep)  != NULL) i_deep = 1;
   if(strstr(nc_block_in,brkchp)!= NULL) i_brkchp = 1;
   if(strstr(nc_block_in,tap)   != NULL) i_tap = 1;
   if(strstr(nc_block_in,bore)  != NULL) i_bore = 1;
   if(strstr(nc_block_in,drag)  != NULL) i_drag = 1;
   if(strstr(nc_block_in,nodrag)!= NULL) i_no_drag = 1;

   if(strstr(nc_block_in,option) != NULL) i_option = 1;
   else i_option = 0;
/* read parameters from CLS command */
   if((s1 = strstr(nc_block_in, rapto)) != NULL) 
   { 
      sscanf(s1+6, "%lf", &d_rapto); 
      i_rapto = 1; 
   } 
   if((s1 = strstr(nc_block_in, fedto)) != NULL) 
   { 
      sscanf(s1+6, "%lf", &d_fedto);	
      i_fedto=1; 
   }
   if((s1 = strstr(nc_block_in, rtrcto)) != NULL)  
   {
      if(strstr(nc_block_in, "AUTO") != NULL) 
      { 
         d_rtrcto = d_rapto; 
         i_rtrcto = 1;
      }
      else 
      { 
         sscanf(s1+7, "%lf", &d_rtrcto); 
         i_rtrcto = 1;	
      }
      
   }
   else if(i_rapto) 
   { 
      d_rtrcto = d_rapto;	
      i_rtrcto = 1;	
   }
   if((s1 = strstr(nc_block_in, mmpr)) != NULL)  
   { 
      sscanf(s1+5, "%lf", &d_feed ); 
      i_feed = 1; 
   }
   if((s1 = strstr(nc_block_in, mmpm)) != NULL)  
   { 
      sscanf(s1+5, "%lf", &d_feed );	
      i_feed = 1; 
   }
   if((s1 = strstr(nc_block_in, dwell)) != NULL)  
   { 
      sscanf(s1+6, "%lf", &d_dwell);	i_dwell=1;	
   }
   if((s1 = strstr(nc_block_in, step)) != NULL)  
   {
      sscanf(s1+5, "%lf", &d_step1); 
      i_step1 = 1;
      s2=strstr(s1+5,",");
      if(s2 != NULL && isdigit(*(s2+1))) 
      { 
         sscanf(s2+1, "%lf", &d_step2);	
         i_step2 = 1; 
      }
   }   
   if((s1 = strstr(nc_block_in, cskdia)) != NULL) 
   { 
      sscanf(s1+7, "%lf", &d_cskdia);	
      i_cskdia = 1; 
   }
   if((s1 = strstr(nc_block_in, tlangl)) != NULL) 
   { 
      sscanf(s1+7, "%lf", &d_tlangl);	
      i_tlangl = 1; 
   }
   if((s1 = strstr(nc_block_in, holdia)) != NULL) 
   { 
      sscanf(s1+7, "%lf", &d_holdia);	
      i_holdia = 1; 
   }
   if((s1 = strstr(nc_block_in, nodrag)) != NULL) 
   { 
      sscanf(s1+7, "%lf", &d_nodrag);	
      i_nodrag=1; 
   }
   if((s1 = strstr(nc_block_in, cam)) != NULL) 
   { 
       sscanf(s1+4, "%lf", &d_cam); 
       i_cam = 1;
   } 
   /* correction parameter by cycle type */
   if(i_csink)	
   {
      d_tlangl = d_tlangl/180*M_PI;
      d_fedto = (d_cskdia/2)/tan(d_tlangl/2);
   }
   if(i_tap)		/* CYCLE TAP L74 AND L78 */
   {
      irc = uc1603(mess1, 1, menu_list_1, 2);
      if(irc==6) 
      { 
         i_l78 = 1;	 
         strcpy(c_dirrot," R6="); /* change key word for L78 cycle */	
      }
	  else i_l74 = 1;
      irc = uc1603(mess2, 1, menu_list_2, 2);
  	  if(irc==6) 
      { 
         d_dirrot = 4.0;	
         d_revrot = 3.0;	
      }
	  else
      { 
         d_dirrot = 3.0; 
         d_revrot = 4.0;	
      }
   }
   do			/* Loop until we read CICLE/OFF comman */
   {
      if((s1 = strstr(nc_block_in, m_goto)) != NULL)
      {
         ret_num = XYZ_input(s1+5, &x, &y, &z, &i_int, &j_int, &k_int, mill_mode);
         if(ret_num<6) {i_int=*i_old; j_int=*j_old; k_int=*k_old; }
		 else if(fabs(b_calculation(i_int,j_int,k_int) - b_old) > 0.01) 
         /* The changing of B coordinta is			
            is now allowed inside of cicle  */
         {PTP(" ERROR Changing of B coordinat inside cycle");}
         c_calculation(i_int,j_int,k_int,&Cr,&C);
         x_option = x, y_option = y, z_option = z;
         if (i_int == 1.0)
		 {  
	        if(y == 0.0 && z >= 0.0) { C = 0.0; Cr = 0.0; }
            else
            {
               Len = Len2(y,z); Cr = atan2(y/Len,z/Len); C = (Cr)*180/M_PI; 
               if (C<0.0) C=360.0 + C;
  			   z = Len2(z,y); y = 0.0;
            }
		 }
	     else C_rotate (&y,&z,Cr);  /* common rotate of C axis  why not B_axis ??? */
  	     C=c_correction(C); C=around (C); y=around(y); z=around(z); x=around(x);
	     if(C != c_old) sprintf(s_c," G68 C1=%.3lf", C);
         else strcpy (s_c,"");
         if(y != *y_old) sprintf(s_y," Y1=%.3lf", y);
         else strcpy(s_y,"");
         if(x != *x_old) sprintf(s_x," E1=%.3lf", z);     
         else strcpy(s_x,"");
         if(z != *z_old) sprintf(s_z," Z1=%.3lf", x + d_rapto);     
         else strcpy(s_z,"");
         if(type_of_goto != 0) 
         { 
            strcpy(COMMAND," G0"); 
            type_of_goto=0; 
         } 
         else strcpy(COMMAND,"");
         if((C != c_old || y != *y_old) && i_option == 0)
         {
            strcat(strcat(strcpy(nc_block_out,COMMAND),s_c),s_y);
		    PTP(nc_block_out);
         }
/*
         else if(i_option == 1)
         {
            if(y_option != y_option_old) sprintf(s_y," Y1=%.3lf", y_option);
            else strcpy(s_y,"");
            if(z_option != z_option_old) sprintf(s_x," E1=%.3lf", z_option);     
            else strcpy(s_x,"");
            if(x_option != x_option_old) sprintf(s_z," Z1=%.3lf", x_option + d_rapto);     
            else strcpy(s_z,"");
            strcat(strcat(strcat(strcpy(nc_block_out,COMMAND),s_x),s_y),s_z);
            PTP(nc_block_out);
         }
*/
         else if(i_option == 1)
         {
            if(y_option != y_option_old) 
            { 
                sprintf(s_y," Y1=%.3lf", y_option);
                strcat(strcpy(nc_block_out,COMMAND),s_y);
                PTP(nc_block_out);
            }
            else strcpy(s_y,"");
            if(z_option != z_option_old) sprintf(s_x," E1=%.3lf", z_option);     
            else strcpy(s_x,"");
            if(x_option != x_option_old) sprintf(s_z," Z1=%.3lf", x_option + d_rapto);     
            else strcpy(s_z,"");
         }
	  /* define modality of parameters */
	     if(i_dwesta)  
         { 
             sprintf(s_dwesta,"%s%.3lf",c_dwesta,d_dwesta); 
             i_dwesta=0; 
         } 
         else strcpy(s_dwesta,"");
         if(i_fedto)   
         { 
             sprintf(s_fedto, "%s%.3lf",c_fedto, fabs(d_fedto) ); 
             i_fedto =0; 
         } 
         else strcpy(s_fedto, "");
	     if(i_step1)   
         { 
             sprintf(s_step1, "%s%.3lf",c_step1, d_step1 ); 
             i_step1 =0; 
         } 
         else strcpy(s_step1, "");
	     if(i_rapto)   
         { 
             sprintf(s_rapto, "%s%.3lf",c_rapto, d_rapto ); 
             i_rapto =0; 
         } 
         else strcpy(s_rapto, "");
	     if(i_dwell)   
         { 
             sprintf(s_dwell, "%s%.3lf",c_dwell, d_dwell ); 
             i_dwell =0; 
         } 
         else strcpy(s_dwell, "");
	     if(i_step2)   
         { 
             sprintf(s_step2, "%s%.3lf",c_step2, d_step2 ); 
             i_step2 =0; 
         } 
         else strcpy(s_step2, "");
	     if(i_revrot)  
         { 
             sprintf(s_revrot,"%s%.3lf",c_revrot,d_revrot); 
             i_revrot=0; 
         } 
         else strcpy(s_revrot,"");
	     if(i_dirrot)  
         { 
             sprintf(s_dirrot,"%s%.3lf",c_dirrot,d_dirrot); 
             i_dirrot=0; 
         } 
         else strcpy(s_dirrot,"");
	     if(i_cam)     
         { 
             sprintf(s_cam,   "%s%.3lf",c_cam,   d_cam   ); 
             i_cam   =0; 
         } 
         else strcpy(s_cam, "");
	     if(i_rtrcto)  
         { 
             sprintf(s_rtrcto,"%s%.3lf",c_rtrcto,d_rtrcto); 
             i_rtrcto=0; 
         } 
         else strcpy(s_rtrcto,"");
	     if(i_feed)    
         { 
             sprintf(s_feed,  "%s%.3lf",c_feed,  d_feed  ); 
	         sprintf(s_ffeed, "%s%.3lf",c_ffeed, d_feed  ); 
             i_feed  =0; 
         } 
         else 
         { 
             strcpy(s_feed,  "");	
             strcpy(s_ffeed,  "");	
         }
         if(z != z_old_cycle && i_option == 0) 
         { 
             sprintf(s_z,"%s%.3lf", c_z, z);
         }
         else if(i_option == 1)
         {
             if(z_option != z_option_old)
             sprintf(s_z,"%s%.3lf", c_z, z_option);
             else strcpy(s_z, "");
         }
         else strcpy(s_z, "");
         if(x != x_old_cycle && i_option == 0) 
         { 
             sprintf(s_x,"%s%.3lf", c_x, x);             
         }
         else if(i_option == 1)
         {
             if(x_option != x_option_old)
             sprintf(s_x,"%s%.3lf", c_x, x_option);
             else strcpy(s_x, "");
         }
         else strcpy(s_x, "");
         if(i_nodrag)  
         { 
             sprintf(s_nodrag,"%s%.3lf",c_nodrag,d_nodrag); 
             i_nodrag=0; 
         } 
         else strcpy(s_nodrag,"");
         *x_old=x; *y_old=y; *z_old=z; c_old=C;	
         x_old_cycle=x; z_old_cycle=z;
         *i_old=i_int; *j_old=j_int; *k_old=k_int;
         x_option_old = x_option; 
         y_option_old = y_option;
         z_option_old = z_option;
/*=================== CICLE OUTPUT ===========================*/

/* L72 	*/
         if(i_drill && !i_deep && !i_brkchp && d_dwell > 0.0) 
         {
            strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcpy(  
		    nc_block_out,s_rapto),s_fedto),s_rtrcto),s_dwell),s_z),s_x)," L72"),s_ffeed);
         }
/* L71	*/
         if(i_drill && !i_deep && !i_brkchp && d_dwell == 0.0)
         {
            strcat(strcat(strcat(strcat(strcat(strcat(strcpy(  
		    nc_block_out,s_rapto),s_fedto),s_rtrcto),s_z),s_x)," L71"),s_ffeed);
         }
/* L70 	*/
         if(i_drill && i_brkchp  && !i_deep)
         {
            strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcpy(  
            nc_block_out,s_step1),s_rapto),s_fedto),s_rtrcto),s_dwell),s_step2),s_z),s_x)," L70"),s_ffeed);
         }
/* L73 	*/
         if(i_drill && !i_brkchp && i_deep)
         {
            strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcpy(  
		    nc_block_out,s_dwesta),s_step1),s_rapto),s_fedto),s_rtrcto),s_dwell),s_step2),s_z),s_x)," L73"),s_ffeed);
         }
/* L75	*/
         if(i_bore && !i_drag && !i_nodrag)
         {
            strcat(strcat(strcat(strcat(strcat(strcat(strcpy(  
            nc_block_out,s_rapto),s_fedto),s_rtrcto),s_z),s_x)," L75"),s_ffeed);
         }
/* L76	*/
         if(i_bore && (i_drag || i_nodrag))
         {
            strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcpy(  
		    nc_block_out,s_rapto),s_fedto),s_rtrcto),s_z),s_x),s_nodrag)," L76"),s_ffeed);
         }
/* L74 */
         if(i_tap && i_l74)
         {
            strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcpy(  
            nc_block_out,s_rapto),s_fedto),s_revrot),s_dirrot),s_rtrcto),s_feed),s_z),s_x)," L74");
         }
/* L78 */
         if(i_tap && i_l78)
         {
            strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcat(strcpy(  
            nc_block_out,s_rapto),s_fedto),s_dirrot),s_cam),s_rtrcto),s_feed),s_z),s_x)," L78");
         }
         PTP(nc_block_out);
      }
      else if((s1 = strstr(nc_block_in, cycle_off)) != NULL)
      {      
          i_option = 0;
          break;
      }
      else if((s1 = strstr(nc_block_in, cycle_on )) !=NULL )	/* new parameters of cycle */
      {
        /* read parameters from CYCLE/ON command */
         if((s1 = strstr(nc_block_in, option))!= NULL) i_option = 1;
         else i_option = 0;
         if((s1 = strstr(nc_block_in, rapto)) != NULL) { sscanf(s1+6, "%lf", &d_rapto); i_rapto=1; } 
         if((s1 = strstr(nc_block_in, fedto)) != NULL) { sscanf(s1+6, "%lf", &d_fedto);	i_fedto=1; }
         if((s1 = strstr(nc_block_in, rtrcto))!= NULL)  
 	     {
            if(strstr(nc_block_in, "AUTO") != NULL) { d_rtrcto = d_rapto; i_rtrcto = 1;}
            else { sscanf(s1+7, "%lf", &d_rtrcto); i_rtrcto = 1;	}
         }
         else if(i_rapto) { d_rtrcto = d_rapto;	i_rtrcto = 1;	}
         if((s1 = strstr(nc_block_in, mmpr)) != NULL)  { sscanf(s1+5, "%lf",    &d_feed ); i_feed =1; }
         if((s1 = strstr(nc_block_in, mmpm)) != NULL)  { sscanf(s1+5, "%lf",    &d_feed );	i_feed =1; }
         if((s1 = strstr(nc_block_in, dwell))!= NULL)  { sscanf(s1+6, "%lf",    &d_dwell);	i_dwell=1;	}
         if((s1 = strstr(nc_block_in, step)) != NULL)  
         {
            sscanf(s1+5, "%lf", &d_step1); i_step1=1;
            s2=strstr(s1+5,",");
            if(s2!=NULL && isdigit(*(s2+1)) ) { sscanf(s2+1, "%lf", &d_step2);	i_step2=1; }
          }   
          if((s1 = strstr(nc_block_in, cskdia)) != NULL) { sscanf(s1+7, "%lf", &d_cskdia);	i_cskdia=1; }
          if((s1 = strstr(nc_block_in, tlangl)) != NULL) { sscanf(s1+7, "%lf", &d_tlangl);	i_tlangl=1; }
          if((s1 = strstr(nc_block_in, holdia)) != NULL) { sscanf(s1+7, "%lf", &d_holdia);	i_holdia=1; }
          if((s1 = strstr(nc_block_in, nodrag)) != NULL) { sscanf(s1+7, "%lf", &d_nodrag);	i_nodrag=1; }
	      if((s1 = strstr(nc_block_in, cam   )) != NULL) { sscanf(s1+4, "%lf", &d_cam   ); i_cam   =1; } 
      /* correction parameter by cycle type */
         if(i_csink && (i_cskdia || i_tlangl)) 
         {	
             d_tlangl = d_tlangl/180*M_PI;
             d_fedto  = (d_cskdia/2)/tan(d_tlangl/2); 
             i_fedto  = 1; 
         }
      }
   }while ((in = uc4514(chanel_in, nc_block_in) >= 0));		 
   /* end of while cycle */
   i_option = 0; 
}

