#define M_PI 3.14159265358979 

/* Include files */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <fcntl.h>
#include <errno.h>
#include <math.h>
#include <ctype.h>
#include <wchar.h>

#include <uf.h>
#include <uf_cfi.h>
#include <uf_ui.h>
#include <uf_object_types.h>
#include <uf_disp.h>
#include <uf_modl.h>
#include <uf_curve.h>
#include <uf_defs.h>
#include <uf_exit.h>
#include <uf_csys.h>
#include <uf_part.h>

#include "m100_header.c"

/* Functions declaration */

int  f_tldata(char *str_1);
void f_coolnt(char *str_1);
void f_delay (char *str_1);
void f_spindl(int chanel_in, int mill_mode, char *str_1);
void cycle_process      (int chanel_in,double b,
                         double *x,double *y, double *z,  
                        double *i,double *j, double *k );
void f_gohome           (int mill_mode, char *str_1);

int  f_load_tool(double *coord_b1, int multi_axis, char *str_1);
int  f_cutcom(char *str_1);

/* Function in service_fun.c */

struct msys { double p[9]; double c; };

void delete_right_zero  ( char *str_1);
void PTP                ( char *s);
void PTP_STOP           (char *message);
void PTP_CLOSE          (char *message);
void reset_XYZC         ();
void circle_process_mill( double B,
                          double coord_x,  double coord_y,   double coord_z, 
                          double Center_x, double Center_y,  double Center_z, 
                          double Normal_x, double Normal_y,  double Normal_z, 
                          double End_x,    double End_y,     double End_z,
                          double radius,   double tolerance, double ratio, double angle );
void position_out       ( double *position);
void B_rotate           ( double *x, double *z, double xoff, double	zoff, double b );
void C_rotate           ( double *y, double *z, double c);	
void c_calculation      ( double i,  double  j, double k, double *cr, double *c);
void   circle_unite     ( double  Xc, double  Yc, double  Zc,
                          double  Nx, double  Ny, double  Nz, double R,
                          double *Xe, double *Ye, double *Ze, double *angle);
void f_compensation	    (char *s, int *com, int *type_of_comp);                           


int  ask              ( char *si, char *kyeword, double *x);
int  XYZ_input        ( char *s, double *x, double *y, double *z, double *i, double *j, double *k, int mill_mode);
int  look_goto        ( double *b_coor);
int  circle_direction ( double Bx, double By, double Bz,
                        double Cx, double Cy, double Cz,
                        double Ex, double Ey, double Ez,
                        double Nx, double Ny, double Nz );
int  compare_msys     ( struct msys m1, struct msys m2);


char   *add_cls(char *out, char *inp);
char	  *add_number(char *s);
char   *add_feedrate( char *s);


double around        ( double x);
double Len2          ( double x, double y);
double Len3          ( double x, double y, double z);
double b_calculation ( double i, double j, double k);
double c_correction  ( double c); 

/* Measuring function */

void f_l822(), f_l823(), f_l824(), f_l825(), f_l827(), f_l828(), f_l830(), f_l831(), f_l832();
void f_l833(), f_l834(), f_m56(),  f_m57 (), f_m13 (), f_m14 (), f_l9999();
void f_l930(int zero_shift), f_l931(int zero_shift), f_m19(int mill_mode);

/* Global variable */

char file_name[256] = "\0";
char cls_file[256], ptp_file[256], str_goto_f[256];
char nc_block_in[256], nc_block_out[256], str_goto[256];

/* TOOL DATA DEFINITION */

SDT_MILL_TOOL_t          mill_tool;
BARREL_MILL_TOOL_t       barrel_tool;
TCUTTER_MILL_TOOL_t      tcutter_tool;
DRILL_TOOL_t             drill_tool;
STD_TURN_TOOL_t          turn_tool;
BUTTON_TURN_TOOL_t       button_tool;
BAR_TURN_TOOL_t          bar_tool;
SDT_GROOVE_TURN_TOOL_t   groove_tool;
ANGLE_GROOVE_TURN_TOOL_t angle_groove_tool;
SDT_THREAD_TURN_TOOL_t   thread_tool;
BUT_THREAD_TURN_TOOL_t   but_thread_tool;
ACME_THREAD_TURN_TOOL_t  acme_thread_tool;

int    i_cancel=2;                         /* the code return after CANSEL command in dialog */
int    fedrat_on;	                         /* set of feed rate command */
int    type_of_goto=-1;                    /* -1 unknown, 0-G0, 1-G1, 2-G2, 3-G3 */
char   feedrate[12];                       /* string with feedrate command */
int    plane_of_circle= -1;																/* 1 - Y1 x Z1 (	E1=const normal to tool axis)
				2 - E1 x Y1 ( normal of cricle || to acis of spindel )
				3 - Z1 x E1 ( common plane of circle in turn operation */
int    tool_sys;                           /* set of tool sys coordinat (command l843) */
int    block_num=1, chanel_out, chanel_in; 
int    i_rotate_c=0;                       /* flag of C rotation on 180 degree */
int    mill_mode=-1;                       /* flag of milling operation */
int    from_move = 0;                      /* this variable set a flag of FROM POINT in operation */		 
int    tool_change=1;                      /* this variable calculate a numbers of tool change cycles */
																																													
double Xold,Yold,Zold,Cold;		              /* the old coordiant from CLS line */
double rotate;		                           /* curren angle of C correction */
double tmp1,tmp2,tmp3;

