/*===========================================================================
	  Copyright 1998 (c) Electronic Data Systems Corporation
	                  Moscow Office 
	        Unpublished - All rights reserved
                   PROGRAM NAME:  m100.c
                   AUTHOR:        Chizh Oleg
                   CREATION DATE: 06-06-1998 
		   VERSION:       2.0
===========================================================================*
/***************************************************************************
 *                                                                         *
 * This is a C program written for Internal User Function.                 *
 * Its is postprocessor mit non standart cycles for NC machine M100        *
 * Voest-Alpine and controller Sinumeric 840C                              *
 *                                                                         *
 *                                                                         *
 ***************************************************************************
/*  This source code compile, link and testing for HP-UX v10.20            *
 *                         and for Windows NT v4.0 with Service Pack 3     *
 ***************************************************************************/
#include "global_definition.c"

#define VERSION 13          /* Version of Unigraphics */
#define SERVER_NAME "s1" /* Define server name */
#define WINNT   0           /* Type operation system 1-WNT 0-UNIX */

void ufusr(char *param, int *retcod, int param_len)
{

/* Variables in main program */

   char s3[30] = ""; 
   char inp_values[1][31]={1};
   char *mes_prog_num="Enter Program Number";
   char menu_list[1][16]={"Program number"};
   char menu_list_1[2][38]={"Not using 5 axis simultaneous", 
                            "Using 5 axis simultaneous"};
   double initial_d = 0.0; 
   int type_item[1]={100};
   char tool_path[256];

/* Variable of menu tool change cycle L106 */
   int     r_param_i[2] = {1, 0};
   int     tool_items[2] = {100, 100};
   double  r_param_d[2] = {0.0, 0.0};
   char    tool_menu_list[2][16] = {"R1=", "R3="};   
   char    r_param_c[2][31] = {"0", "0"};
   char    *message_tool="Input parameters in tool change cycle for tool N ";
   char    message_tool_1[128];
/*--------------------------------------------*/
   char   *s1, *s2, *filter = "*.cls", error[133];
   int    type_operation, t_orient = 0, rapid_mod, len_str;
   int    tool_num, part_no = 1; 
   int    comp, type_of_comp=0, irc, in ;
   int    rapid_move = 1, move_mode = 1, lin_move=1, angle_move, multi_axis = 1,first_move = 0;
   int    upcom=0, done_comp=0;
   double tool_angle, d_fedrat, coord_b1 = 0.0;
   double Iold, Jold, Kold;
   double origin_x, origin_y, origin_z;
   double feed_rate_comp;
   double tolerance, ratio, angle;
   double E1,E1_old,Z1,Z1_old,Y1,Y1_old,B1,B1_old,C1,C1_old;
   double Tool, dE1,dZ1,dY1,dC1,dB1, dX,dY,dZ;

/* THREAD PARAMETER */
   
   double d_pitch,d_varpinch;
   int    i_decr,i_incr,i_thread_param,i_turn;


/* Variables functions in CAM operation create */
  
   char *l930="L930", *l931="L931", *m56="M56", *m57="M57", *m13="M13", *m14="M14";
   char *l822="L822", *l823="L823", *l824="L824", *l825="L825", *l827="L827"; 
   char *l828="L828", *l830="L830", *l831="L831", *l832="L832", *l833="L833"; 
   char *l834="L834", *m19="M19", *l9999="L9999", *l843="L843", *l844="L844"; 

/* Variables function in CLS FILE */
  
   char *tldata = "TLDATA/", *coolnt = "COOLNT/", *delay = "DELAY/", *disply = "DISPLY/";
   char *fedrat_mmpr = "FEDRAT/MMPR", *fedrat_mmpm = "FEDRAT/MMPM";
   char *fedrat = "FEDRAT/";
   char *gohome = "GOHOME/", *load_tool = "LOAD/TOOL", *opstop = "OPSTOP";
   char *origin = "ORIGIN/", *partno = "PARTNO/", *rapid = "RAPID", *m_goto = "GOTO/";
   char *set_turn = "SET/MODE,TURN", *set_mill = "SET/MODE,MILL", *turret = "TURRET/";
   char *select = "SELECT/TOOL", *cutcom = "CUTCOM/", *spindl = "SPINDL/";
   char *cycle = "CYCLE/", *cycle_off = "CYCLE/OFF", *from = "FROM/", *circle = "CIRCLE/";
   char *thread_turn="THREAD/TURN", *thread_on="THREAD/ON", *thread_face="THREAD/FACE";
    
   char COMMAND[100];
   int  units = UF_PART_METRIC;
   int  response = UF_UI_OK;
   int  max_speed, zero_shift = 54;
   char *mes_sel_zero = "Select zero shift";
   char menu_list_23[3][38]={"MAX Speed = 1600 rev.", "MAX Speed = 560 rev.", "MAX Speed = 1000 rev."};
   char menu_list_10[4][38]={"G54", "G55", "G56", "G57"};
   char menu_list_11[3][38]={"Tool angle = 0 degree", "Tool angle = -90 degree", "Input tool angle"};
   char *mes_tool_angle = "Input tool orientation angle";
   char menu_list_12[1][16]={"Tool angle"};
   char *s_name="";
   /* --<new variable>-------*/

   int    CM,file_pos;									
   int	  meas_tool; /* if measurnig 1, else 0 */
   int    out_move;   /* control GOTO output by coordinat modality*/

   double X,Y,Z,I,J,K;    /* the current coordiant from CLS line */
   double Xout,Yout,Zout,C,Cr,Br; /* the current coordiant from CLS line */

   double Xe,Ye,Ze, Xc,Yc,Zc, Nx,Ny,Nz, R;  /* end point, center, normal and R of circle */
   double Xoff,Zoff;                        /* the shift for B rotation */
   double Lpart,Lmas;

/* MSYS parameter */

   struct msys nm,  m[10];
   int    n=0, cur, i;  /* n - number of msys,   curr - currrent msys index */

   int    rel_num=0;
   char   open_part[133], *relnum = "V13";
   tag_t  part_tag;
   char   *str_1 = " ";
   char   *str_2 = "Version of UNIGRAPHICS must be ";

   int serv_name = 0;


/* DEBUGGING */

   double Yc_cls,Zc_cls,Y_goto,Z_goto,Cr_goto;
   Xold=Yold=Zold=Cold=coord_b1=-999999.99;
/* Reset of coordinate */

   UF_initialize();    /* Initialize UGOPEN program */

   part_tag = UF_PART_ask_display_part();
   UF_PART_ask_part_name(part_tag, open_part);
   uc4623(open_part, relnum);
   str_1=(strstr(relnum, "V"));  
   sscanf(str_1+1, "%d", &rel_num); 
   sprintf(str_2, "%s%d", str_2, VERSION);

#if (WINNT)
   system("echo %ACS_MASTER% > d:\\temp\\acs_name");
   chanel_in = uc4504("d:\\temp\\acs_name", 1, 2004);
#else
   system("echo $ACS_MASTER > /tmp/acs_name");
   chanel_in = uc4504("/tmp/acs_name", 1, 2004);
#endif
   if(chanel_in < 0)
   {
      UF_get_fail_message(chanel_in, error);
      uc1601(error, 1);
   }
   while((in = uc4514(chanel_in, nc_block_in) >= 0))
   {
      strcpy(s_name, SERVER_NAME);
      s2 = strstr(nc_block_in, SERVER_NAME);
#if (WINNT)
      strncpy(s3, s2, strlen(s2)-1);
#else
      strncpy(s3, s2, strlen(s2));
#endif
      if((strcmp(s3, s_name) == 0)) serv_name = 1;
      else serv_name = 0;
   }
   uc4540(chanel_in, 0);

#if (WINNT)
   system("del  d:\\temp\\acs_name");
#else
   system("rm /tmp/acs_name");
#endif
      
   if(rel_num > VERSION || serv_name != 1) 
   {
      if(rel_num > VERSION)
      {
         uc1601(str_2, 1);
      }
      else
      {
         uc1601("Cannot connect to ACS Server", 1);
      }
   }
   else if((irc = uc5000(s3)) == 0)
   {
      uc1601("Not active part. Pleas create new part or open existing", 1);
   }
   else
   {
      /* Set selection mask for CLS files */
      UF_UI_set_dialog_filter(UF_UI_PART_NEW_FLTR, filter);
      /* Select CLS file for Postprocessing */
      irc = UF_UI_ask_create_part_filename(file_name, &units, &response);
      if(irc)
      {
         UF_get_fail_message(irc,error); 
         uc1601(error, 1); 
         exit(1);
      }
      /* Convert string file name to ptp and dnc file and running GPM */
      len_str = strlen(file_name);
      strncat(ptp_file, file_name, (len_str-3));
      strcat(ptp_file, "doc");

      /*  Open files to input and output */

      chanel_in = uc4504(file_name, 1, 2004);
      if(chanel_in < 0)	{ UF_get_fail_message(chanel_in, error); uc1601(error, 1);	}

      chanel_out = uc4504(ptp_file, 3, 2004);
      if(chanel_out < 0) { UF_get_fail_message(chanel_out, error); uc1601(error, 1); }

      /* Input program number */

      irc = uc1613(mes_prog_num, menu_list, 1, &part_no, &initial_d, 
      inp_values, type_item);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
      sprintf(nc_block_out, "(%%MPF%d)", part_no);	uc4524(chanel_out, nc_block_out);
   
      /* Selection mode of cutting */

      mes_prog_num = "Select works mode (Fixed or Variable Axis)";
      irc = uc1603(mes_prog_num, 1, menu_list_1, 2); 
      if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
      if (irc==6) multi_axis = 1;
	  else        multi_axis = 0;
  
      /* Select zero shift and maximum speed of spindel  */

      mes_sel_zero = "Select zero shift";
      irc = uc1603(mes_sel_zero, 1, menu_list_10, 4);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
      switch(irc)
      {
         case  5: zero_shift = 54;	break;
         case  6: zero_shift = 55;	break;
         case  7: zero_shift = 56;	break;
         case  8: zero_shift = 57;	break;
         default: zero_shift = 54;
      }
      sprintf(nc_block_out, " G%d",zero_shift);	PTP(nc_block_out);

      mes_sel_zero="Select maximum speed of spindel rotation";
      irc = uc1603(mes_sel_zero, 1, menu_list_23, 3);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
      switch(irc)
      {
         case 5 : max_speed = 1600;	break;     
         case 6 : max_speed = 560 ;	break;
         case 7 : max_speed = 1000;	break;
         default: max_speed = 1600;
      }
      sprintf(nc_block_out, " G26 S1=%d", max_speed); 	PTP(nc_block_out);

      /* ==================> Read CLS file while not read EOF <===========================*/

      while((in = uc4514(chanel_in, nc_block_in) >= 0))
      { 
      /* TOOL PATH/ */		 
      if ((s1 =strstr(nc_block_in, "TOOL PATH/"))!=NULL)
      {
         strcat(strcat(strcpy(nc_block_out," ("),s1+10),")");	PTP(nc_block_out);
         strcpy(tool_path,nc_block_in);
      }
      else if ((s1=strstr(nc_block_in,"PAINT/"))!=NULL)
      {
	      ;
      }
      /* MSYS */  
      else if ((s1=strstr(nc_block_in,"MSYS/"))!=NULL)
      {
         sscanf(s1+5,"%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf",
	     	&nm.p[0],&nm.p[1],&nm.p[2],&nm.p[3],&nm.p[4],&nm.p[5],&nm.p[6],&nm.p[7],&nm.p[8]);
	 if (n==0){ cur=0; m[cur]=nm; m[cur].c=rotate=0.0; }
	 else
	 {
            for (i=0, cur=-1; i<=n; i++) if (compare_msys(m[i],nm)) cur=i;
            if  (cur==-1) { cur= (++n); m[cur]=nm; m[cur].c=rotate=-999999.999; }
         }  
      /* sprintf (nc_block_out," ( MSYS N=%d, C_ROTATE=%lf )", cur, m[cur].c); PTP(nc_block_out); */
      }
      /* ROTATE */ 
      else if ((s1=strstr(nc_block_in,"ROTATE/CAXIS"))!=NULL)
      {
         sscanf  (s1+13,"%lf",&rotate); rotate = around(rotate); m[cur].c = rotate;
	 sprintf (nc_block_out," G68 G0 C1=%.3lf",rotate); 
	 PTP(nc_block_out);
         sprintf (nc_block_out," ( after ROTATE: MSYS N=%d, C_ROTATE=%lf )", cur, m[cur].c); 
	 PTP(nc_block_out);
      }
      /* TLDATA/ */   
      else if((s1 = strstr(nc_block_in, tldata)) != NULL) 
      {
         type_operation = f_tldata(nc_block_in);
         if(type_operation == 5)
         {
            if((s1 = strstr(turn_tool.tool_orient, "RIG")) != NULL) t_orient = 180;
            else t_orient = 0;
            tool_angle = turn_tool.orient_angle - 270.0;
         }
         else if(type_operation == 6)
         {
            if((s1 = strstr(button_tool.tool_orient, "RIG")) != NULL) t_orient = 180;
            else t_orient = 0;
            tool_angle = button_tool.orient_angle - 270.0;
         }
         else if(type_operation == 7)
         {
            if((s1 = strstr(bar_tool.tool_orient, "RIG")) != NULL) t_orient = 180;
            else t_orient = 0;
            tool_angle = bar_tool.orient_angle - 270.0;
         }
         else if(type_operation == 8)
         {
            if((s1 = strstr(groove_tool.tool_orient, "RIG")) != NULL) t_orient = 180;
            else t_orient = 0;
            irc = uc1603(mes_sel_zero, 1, menu_list_11, 3);	
	    if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
            switch(irc)
            {
               case  5: tool_angle = 0.0;    break;
               case  6: tool_angle = -90.0;  break;
               case  7: uc1609(mes_tool_angle, menu_list_12, 1, &tool_angle, &irc);   break;
               default: tool_angle = 0.0;
            }
         }
         else if(type_operation == 9)
         {
            if((s1 = strstr(angle_groove_tool.tool_orient, "RIG")) != NULL) t_orient = 180;
            else t_orient = 0;
            irc = uc1603(mes_sel_zero, 1, menu_list_11, 3);	
	    if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
            switch(irc)
            {
               case  5: tool_angle = 0.0;    break;
               case  6: tool_angle = -90.0;  break;
               case  7: uc1609(mes_tool_angle, menu_list_12, 1, &tool_angle, &irc);   break;
               default: tool_angle = 0.0;
            }
         } 
         else if(type_operation == 11)
         {
            t_orient = 0;
            tool_angle = -90.0; 
         }
         else 
         {
            t_orient = 0;
            tool_angle = 0.0; 
         } 
      }
      /* SET/TURN */   
      else if((s1 = strstr(nc_block_in, set_turn)) != NULL) 
      {
         PTP(" G90");	PTP(" L920");  mill_mode = 0; Xold=Yold=Zold=-999999.99;
      }
      /* SET/MILL */   
      else if((s1 = strstr(nc_block_in, set_mill)) != NULL) 
      {
         PTP(" G90"); PTP(" L918"); mill_mode = 1;		Xold=Yold=Zold=-999999.99;
      }
      /* COOLNT */   
      else if((s1 = strstr(nc_block_in, coolnt)) != NULL)	f_coolnt(s1);
      /* DELAY  */   
      else if((s1 = strstr(nc_block_in, delay)) != NULL)	f_delay (s1);
      /* DISPLAY */  
      else if((s1 = strstr(nc_block_in, disply)) != NULL)
      {
         strcat(strcat(strcpy(nc_block_out," ("),s1+7),")");	PTP(nc_block_out);
      }
      /* FEDRAT/MMPM or FEDRAT/MMPR */
      else if( (s1 = strstr(nc_block_in, fedrat_mmpr)) != NULL ||
               (s1 = strstr(nc_block_in, fedrat_mmpm)) != NULL)
      {
         sscanf(s1+12, "%lf", &d_fedrat); 
         d_fedrat=around(d_fedrat); sprintf (feedrate," F%.3lf",d_fedrat); 
	 delete_right_zero(feedrate);
         fedrat_on = 1;
      }
      /* FEDRAT */   
      else if((s1 = strstr(nc_block_in, fedrat)) != NULL)
      {
         sscanf(s1+7, "%lf", &d_fedrat);
         d_fedrat=around(d_fedrat); 
	 sprintf (feedrate," F%.3lf",d_fedrat); 
	 delete_right_zero(feedrate);
         fedrat_on = 1;
      }
      /* FROM */   
      else if((s1 = strstr(nc_block_in, from)) != NULL)
      {
         if((XYZ_input(s1+5, &X, &Y, &Z, &Iold,&Jold, &Kold, mill_mode)) == 3) {  Iold=Jold=0.0; Kold=1.0;}
	      if(mill_mode)	coord_b1=b_calculation(Iold,Jold,Kold);
         from_move = 1; type_of_goto=-1;	
         tool_sys=0; /* reset of tool coordinat system */
         Xold=Yold=Zold=-99999999.99;
      }
      /* LOAD/TOOL */   
      else if((s1 = strstr(nc_block_in, load_tool)) != NULL)	
      {
         if(!from_move &&  !look_goto(&coord_b1))
         {  
            PTP_STOP(" ERROR: not FROM and GOTO command with I,J,K parameters");
            break;
	 }
         meas_tool=f_load_tool( &coord_b1, multi_axis, s1);
	 if(tool_change > 200) tool_change = 1;
	 tool_change++;
       }
       /* TURRET */      
       else if((s1 = strstr(nc_block_in, turret)) != NULL)
      {
         sscanf(s1+12, "%d", &tool_num);
         sprintf(message_tool_1, "%s%d", message_tool, tool_num);
         uc1613(message_tool_1, tool_menu_list, 2, r_param_i, r_param_d,
         r_param_c, tool_items);      
         strcpy(message_tool_1, "\0");
         sprintf(nc_block_out, " T1=%d R1=%d R3=%d R4=%.3lf R6=%d L106",
         tool_num, r_param_i[0], r_param_i[1], tool_angle, t_orient);
         PTP(nc_block_out);	
      }
      /* SELECT/TOOL */   
      else if((s1 = strstr(nc_block_in, select)) != NULL)
      {
         sscanf(s1+12, "%d", &tool_num);
         sprintf(nc_block_out, " T1=%d", tool_num++);
         PTP(nc_block_out);
      }
      /* UPCOM   */   
      else if((s1 = strstr(nc_block_in, "UPCOM"))!= NULL)	upcom=1;
      /* OPSTOPT */   
      else if((s1 = strstr(nc_block_in, opstop)) != NULL)	PTP(" M1");
      /* STOP    */   
      else if((s1 = strstr(nc_block_in, "STOP")) != NULL)	PTP(" M0");
      /* ORIGIN  */   
      else if((s1 = strstr(nc_block_in, origin)) != NULL)
		      sscanf(s1+7, "%lf,%lf,%lf", &origin_x, &origin_y, &origin_z);
      /* PART NO */   
      else if((s1 = strstr(nc_block_in, partno)) != NULL)	sscanf(s1+7, "%d", part_no);
      /* SPINDL  */   
      else if((s1 = strstr(nc_block_in, spindl)) != NULL)	f_spindl(chanel_in, mill_mode, nc_block_in);
      /* L930    */   
      else if((s1 = strstr(nc_block_in, l930))   != NULL)	f_l930(zero_shift);
      /* L931    */   
      else if((s1 = strstr(nc_block_in, l931))   != NULL)       f_l931(zero_shift);
      /* CYCLE   */   
      else if((s1 = strstr(nc_block_in, cycle))  != NULL)	
      cycle_process (chanel_in, coord_b1,&Xold,&Yold,&Zold,&Iold, &Jold, &Kold);
      /* CUTCOM  */   
      else if((s1 = strstr(nc_block_in, cutcom)) != NULL)
      {
         if(done_comp!=uc4534(chanel_in) ) f_compensation(nc_block_in, &comp, &type_of_comp);
      }
      /* GOHOME  */   
      else if((s1 = strstr(nc_block_in, gohome)) != NULL)	f_gohome(mill_mode, nc_block_in);
      /* RAPID   */   
      else if((s1 = strstr(nc_block_in, rapid)) != NULL) 
      {
         rapid_mod = 1;
         move_mode = 1;
         strcpy(COMMAND,"G0");
      }
      /* GOTO 5 Axis */
      #include "goto_5_axis.c"
      /* GOTO 3Axis */
      #include "goto.c"
      /* THEARED*/
      #include "thread.c"
      /* CIRCLE */
      #include "circle.c"
      /* L843 */	
      else if((s1 = strstr(nc_block_in, l843)) != NULL)
      {
         uc4514(chanel_in,nc_block_in);
	 if( strstr(nc_block_in,"RAPID")!=NULL) uc4514(chanel_in,nc_block_in);
	 if( strstr(nc_block_in,"GOTO") ==NULL) 
	 { 
	    uc1601("ERROR: L843 command does not have GOTO for origin set", 1);
            uc4540(chanel_out, 0);
            strcat (strcpy(nc_block_out,"rm "),ptp_file);
            system(nc_block_out);
            break;
	 }  
	 Xold=Yold=Zold=-999999.999;	/* reset of coordinat modality */
	 XYZ_input(nc_block_in+5,&Xout,&Yout,&Zout,&tmp1,&tmp2,&tmp3,mill_mode);
   	 C_rotate(&Yout,&Zout,Cr);
         Xoff=Xout; Zoff=Zout;          /* save the shift for B rotataion transform */
         sprintf(nc_block_out," G58 E1=%.3lf Z1=%.3lf",Zout,Xout);  
         PTP(add_cls(add_feedrate(nc_block_out),nc_block_in));      
	 PTP(" L843");
         Br=coord_b1/180.0*M_PI;	
	 tool_sys=1;
	 type_of_goto=-1;
      }
      /* L844 */   
      else if((s1 = strstr(nc_block_in, "L844")) != NULL)
      {
         PTP(" L844"); PTP(" G58 E1=0 Z1=0");
	 Xold=Yold=Zold=-999999.999;	/* reset of coordinat madality */
         tool_sys=0;
	 plane_of_circle=type_of_goto=-1;
      }
      /* END OF PATH */   
      else if ((s1 =strstr(nc_block_in,"END-OF-PATH"))!=NULL) 
      {
         from_move=upcom=0; type_of_goto=-1;	
	 Xold=Yold=Zold=Cold=coord_b1=-999999.99;
      }
      /* M13 */   
      else if ((s1 = strstr(nc_block_in, m13))!=NULL)  f_m13();
      /* M14 */   
      else if ((s1 = strstr(nc_block_in, m14))!=NULL)  f_m14();
      /* M19 */   
      else if ((s1 = strstr(nc_block_in, m19))!=NULL)  f_m19(mill_mode);
      /* M56 */   
      else if ((s1 = strstr(nc_block_in, m56))!=NULL)  f_m56();
      /* M57 */   
      else if ((s1 = strstr(nc_block_in, m57))!=NULL)  f_m57();
      /* L822 */   
      else if ((s1 = strstr(nc_block_in, l822))!=NULL)  { f_l822(); reset_XYZC(); }
      /* L823 */   
      else if ((s1 = strstr(nc_block_in, l823))!=NULL)  { f_l823(); reset_XYZC(); }
      /* L824 */   
      else if ((s1 = strstr(nc_block_in, l824))!=NULL)  { f_l824(); reset_XYZC(); }
      /* L825 */   
      else if ((s1 = strstr(nc_block_in, l825))!=NULL)  { f_l825(); reset_XYZC(); }
      /* L827 */   
      else if ((s1 = strstr(nc_block_in, l827))!=NULL)  { f_l827(); reset_XYZC(); }
      /* L828 */  
      else if ((s1 = strstr(nc_block_in, l828))!=NULL)  { f_l828(); reset_XYZC(); }
      /* L830 */   
      else if ((s1 = strstr(nc_block_in, l830))!=NULL)  { f_l830(); reset_XYZC(); }
      /* L831 */   
      else if ((s1 = strstr(nc_block_in, l831))!=NULL)  { f_l831(); reset_XYZC(); }
      /* L832 */   
      else if ((s1 = strstr(nc_block_in, l832))!=NULL)  { f_l832(); reset_XYZC(); }
      /* L833 */   
      else if ((s1 = strstr(nc_block_in,  l833))!=NULL) { f_l833(); reset_XYZC(); }
      /* L834 */   
      else if ((s1 = strstr(nc_block_in, l834))!=NULL)  { f_l834(); reset_XYZC(); }
   } 	
   /* ====================> End while statement <================================*/
   PTP(" T1=0 R1=1 R3=0 R4=0 R6=0 L106");
   PTP(" T1=0");
   PTP(" M30");
   uc4540(chanel_in, 0);
   uc4540(chanel_out, 0);
   filter = "*.prt";
   UF_UI_set_dialog_filter(UF_UI_PART_NEW_FLTR, filter);
   uc1601("Post Processing Finished", 1);
   }
   UF_terminate();  
}

/* End of main program */

/* Function unload shared image from memory immediatly */

int ufusr_ask_unload(void)
{
  return (UF_UNLOAD_IMMEDIATELY);
}

#include "f_tldata.c"
#include "f_function.c"
#include "measur_proc.c"   /* Include file measur.h for created measuring cycle */
#include "cycle_process.c" /* Include file cycle.h for created standart cycles */
#include "circle_fun.c"    /* CIRCLE processing function */
#include "service_fun.c"   /* Service functions */

#if defined(DEBUG)         /* This funcion is used for debugin without UNIGRAPHICS */
#include "ufun_emulation.c"
#endif

