/* Include file for declaration structures tool parameters */

/* 
  EXAMPLE STRING FOR STD_MILL_TOOL 5 PARAMETERS
  TLDATA/MILL,30.0000,4.0000,75.0000,0.0000,0.0000,11.0000,4.0000

  EXAMPLE STRING FOR STD_MILL_TOOL 7 PARAMETERS
  TLDATA/MILL,30.0000,4.0000,75.0000,0.0000,0.0000,11.0000,4.0000

  EXAMPLE STRING FOR STD_MILL_TOOL 10 PARAMETERS
  TLDATA/MILL,30.0000,40.0000,75.0000,0.0000,0.0000,0.0000,40.0000,4.0000,11.0000,4.0000
*/

typedef struct STD_MILL_TOOL
{
	double diameter,    low_radius,  length,      taper_angle;
	double tip_angle,   x_center_r1, y_center_r1, upper_radius;
	double x_center_r2, y_center_r2;
} SDT_MILL_TOOL_t, *STD_MILL_TOOL_p_t;

/* 
  EXAMPLE STRING FOR BARREL_MILL_TOOL
  TLDATA/BARREL,25.0000,38.0000,1.0000,2.0000,30.0000,25.0000,12.5000,9.5000
*/

typedef struct BARREL_MILL_TOOL
{
	double diameter, bar_radius,   low_radius,  upp_radius;
	double length,   flute_length, y_center_r1, shank_diameter;
} BARREL_MILL_TOOL_t, *BARREL_MILL_TOOL_p_t;

/*
  EXAMPLE STRING FOR TCUTTER_MILL_TOOL
  TLDATA/TCUTTER,25.0000,1.0000,2.0000,50.0000,13.0000,9.5000
*/

typedef struct TCUTTER_MILL_TOOL
{
	double diameter, low_radius, upp_radius, length, flute_length, shank_diameter;
} TCUTTER_MILL_TOOL_t, *TCUTTER_MILL_TOOL_p_t;

/* 
  EXAMPLE STRING FOR DRILL_TOOL (TURN MODE)
  TLDATA/DRILL,LATHE,8.0000,0.0000,50.0000,118.0000,35.0000 
  
  EXAMPLE STRING FOR DRILL_TOOL (MILL MODE)
  TLDATA/DRILL,MILL,8.0000,0.0000,50.0000,118.0000,35.0000 
*/

typedef struct DRILL_TOOL
{
 char module_type[6];
	double diameter, corner_radius, length, point_angle, flute_length;
} DRILL_TOOL_t, *DRILL_TOOL_p_t;

/* 
  EXAMPLE STRING FOR STD_TURN_TOOL
  TLDATA/TURN,LEFT,OUTSIDE,0.0000,30.0000,5.0000,45.0000,150.0000,270.0000
*/

typedef struct STD_TURN_TOOL
{
	char tool_orient[6], type_of_work[8];
	double noze_diam, holder_width, lead_angle, heel_angle, holder_heigth, orient_angle;
} STD_TURN_TOOL_t, *STD_TURN_TOOL_p_t;

/* 
  EXAMPLE STRING FOR BUTTON_TURN_TOOL
  TLDATA/TURN,BUTTON,LEFT,OUTSIDE,12.7000,9.5000,150.0000,270.0000
*/

typedef struct BUTTON_TURN_TOOL
{
	char tool_orient[6], type_of_work[8];
	double noze_diam, holder_width, holder_heigth, orient_angle;
} BUTTON_TURN_TOOL_t, *BUTTON_TURN_TOOL_p_t;

/* EXAMPLE STRING FOR BAR_TURN_TOOL
TLDATA/TURN,BORBAR,RIGHT,OUTSIDE,4.0000,50.0000,
5.0000,5.0000,125.0000,25.0000,180.0000 */

typedef struct BAR_TURN_TOOL
{
	char tool_orient[6], type_of_work[8];
	double noze_diam, holder_width, lead_angle, heel_angle, bar_radius, holder_heigth, orient_angle;
} BAR_TURN_TOOL_t, *BAR_TURN_TOOL_p_t;

/*
  EXAMPLE STRING FOR STD_GROOVE_TURN_TOOL
  TLDATA/GROOVE,RING,LEFT,OUTSIDE,TL,6.2500,8.0000,30.0000,45.0000,45.0000,0.0000,40.0000,70.0000
*/

typedef struct STD_GROOVE_TURN_TOOL
{
	char tool_orient[6], type_of_work[8], trace_size[3];
	double insert_width, left_radius, rigth_radius, max_depth, lead_angle;
	double insert_angle, holder_height, holder_width;
} SDT_GROOVE_TURN_TOOL_t, *STD_GROOVE_TURN_TOOL_p_t;

/*
  EXAMPLE STRING FOR ANGLE_GROOVE_TURN_TOOL
  TLDATA/GROOVE,RING,LEFT,OUTSIDE,TL,6.2500,8.0000,30.0000,45.0000,45.0000,0.0000,40.0000,70.0000 */

typedef struct ANGLE_GROOVE_TURN_TOOL
{
	char tool_orient[6], type_of_work[8], trace_size[3];
	double insert_width, left_angle, rigth_angle, max_depth, lead_angle;
	double insert_angle, holder_height, holder_width;
} ANGLE_GROOVE_TURN_TOOL_t, *ANGLE_GROOVE_TURN_TOOL_p_t;

/* 
  EXAMPLE STRING FOR STD_THREAD_TURN_TOOL
  TLDATA/THREAD,LEFT,OUTSIDE,20.0000,30.0000,60.0000,75.0000,150.0000,6.2500,3.5000 */

typedef struct STD_THREAD_TURN_TOOL
{
	char tool_orient[6], type_of_work[8];
	double max_depth, holder_width, refief_angle, heel_angle;
	double holder_height, insert_width, tip_offset;
} SDT_THREAD_TURN_TOOL_t, *STD_THREAD_TURN_TOOL_p_t;

/* 
  EXAMPLE STRING FOR BUT_THREAD_TURN_TOOL
  THREAD,BUTTRESS,LEFT,OUTSIDE,20.0000,30.0000,5.0000,40.0000,2.0000,150.0000,6.2500,1.2500 */

typedef struct BUT_THREAD_TURN_TOOL
{
	char tool_orient[6], type_of_work[8];
	double max_depth, holder_width, refief_angle, heel_angle, nose_radius;
	double holder_height, insert_width, tip_offset;
} BUT_THREAD_TURN_TOOL_t, *BUT_THREAD_TURN_TOOL_p_t;

/* 
  EXAMPLE STRING FOR ACME_THREAD_TURN_TOOL
  TLDATA/THREAD,ACME,LEFT,OUTSIDE,20.0000,30.0000,60.0000,60.0000,0.0000,150.0000,6.3500,3.5000 */

typedef struct ACME_THREAD_TURN_TOOL
{
	char tool_orient[6], type_of_work[8];
	double max_depth, holder_width, refief_angle, heel_angle;
	double nose_width, holder_height, insert_width, tip_offset;
} ACME_THREAD_TURN_TOOL_t, *ACME_THREAD_TURN_TOOL_p_t;
