/* This function make an arounding of 3 digital after
   decimal point
   ===================================================  */
double around (double x)
{
   double y,arr;
   int    tol = 1000; /* mean three digital after decimal point */
   if(x > 0.0) arr = 0.5; else arr = -0.5;
   y = ((long int)(x*tol + arr))/(double)tol;
   if(y == (-0.0)) y = 0.0 ;
   return(y);
}

/* This function add CSL command to PTP output file
   ================================================  */
char *add_cls(char *so, char *si) /* produce dedug input */
{
   int no,ni,i;
   int debug = 0;
   
   if(!debug) return(so);
   no = strlen(so); ni = strlen(si);
   if((no+ni) < 250)
   {
      if(no < 50)
	  {
	     for(i = no; i < 50; i++) so[i]=' '; so[50]='\0';
	  }
      strcat(strcat(strcat(so," ("),si),")");	
   }
   return (so);
}
/*- Function calculate C axis position -*/
void  c_calculation(double i, double j, double k, double *Cr_out, double *C_out)
{	
   double C,Cr;
	
   if(j == 0.0 && k == 0.0) Cr = 0.0 ;		
   else Cr = atan2(j,k);
   C = (Cr)*180.0/M_PI;
   if(C < 0) C = 360 + C;	
   else if(C > 360) C = C - 360;
   *Cr_out = Cr; *C_out = C;
}
/* Function calculate C angle */
void C_rotate(double *y, double *z, double c)	
{
   double y1,z1;
   
   y1 = (*y)*cos(c) - (*z)*sin(c);
   z1 = (*y)*sin(c) + (*z)*cos(c);		
   (*y) = y1; (*z) = z1;
} 
/*- Function calculate B axis position -*/
double b_calculation(double i, double j, double k)
{
   double angle_b;

   angle_b = -180.0/M_PI * asin(i);
   return (angle_b);
}
/* - Function calculate B angle -*/

void B_rotate (double *x, double *z, double xoff, double	zoff, double b)
{
  double x1,z1;

  x1=  ((*x) - xoff)*cos(b) + ((*z)-zoff)*sin(b);
  z1= -((*x) - xoff)*sin(b) + ((*z)-zoff)*cos(b);
  *x = -x1; *z = z1;
}
/*- Function add block number to string -*/
char *add_number(char *s)
{	
   char s1[256];

   strcpy(s1, s);  
   sprintf(s, "N%04d%s", block_num, s1); 
   block_num++;
   if(block_num >= 9998) block_num = 1;
   return(s);
}

/* This function return od 2D vector length*/

double Len2(double x, double y) {return (sqrt(x*x+y*y));}	

/* This function return od 3D vector length*/

double Len3(double x, double y, double z) {return (sqrt(x*x+y*y*+z*z));}	

/* this function add number, delete all right zero and 
write the command to PTP file */
void PTP(char *s) 
{	
   char s1[256];
   sprintf(s1,"N%04d",block_num); 
   block_num++; 
   if(block_num >= 9998) block_num = 1;
   strcat(s1,s);
   delete_right_zero(s1);
   uc4524(chanel_out,s1);
}
/* This function add feedrate code to end of string*/
	
char *add_feedrate( char *s)
{
   if(fedrat_on) 
   {
      strcat(s,feedrate); 
      fedrat_on=0; 
   }
   return(s);
}
 
/* - This function remove rigth zero all nubmer in string -*/
void delete_right_zero(char *s) 
{
   int n, i, j, k, m, can_delete;
   char s1[256];

   n = strlen(s);
   for(i=0; i < 256; i++) s1[i] = '\0';
   for (i=0,j=0; i<n; )
   {
      if(s[i] != '.') 
      { 
         s1[j] = s[i]; 
         if(s1[j] == '\t') s1[j]=' '; j++; i++; 
      }
      else
      {
      for(k = i + 1; isdigit(s[k + 1]); k++);
         for(can_delete = 1, m = k; m >= i && can_delete; m--)
		 {
		    if(s[m]=='0' || s[m]=='.') s[m]='#';
            else can_delete=0;
         }
		 for(m = i; m <= k; m ++, i ++)
         {
         if(s[m] != '#') 
         { 
            s1[j] = s[i]; 
            j++; 
            }
	 }
      }
   }
   strcpy(s,s1);
}
/* This function ask a parameter after keyword and return
   1 in sucess or 0 in unsecess  */

int ask(char *s, char *key, double *x) 
{	
   char   *p;
   
   p = strstr(s,key);
   if(p != NULL) 
   { 
      sscanf(p+strlen(key),"%lf",x); 
      return(1); 
   }
   return (0);
}
/* This funcition try to unite 
several circle command to single command &*/

void circle_unite(double  Xc, double  Yc, double  Zc,
                  double  Nx, double  Ny, double  Nz, double R,
                  double *Xe, double *Ye, double *Ze, double *angle)
{

  int file_pos;	/* current position of CLS file */
  char s[256];  /* input buffer */

  double XC,YC,ZC, XE,YE,ZE, NX,NY,NZ, Rnew, new_angle;
  double tmp1,tmp2,tmp3;
  		
  file_pos=uc4534(chanel_in);
  uc4514(chanel_in, s); /* read a next GOTO command */
  if(strstr(s,"CIRCLE/") == NULL) uc4535(chanel_in,file_pos); 
  else
  { 
      sscanf(s+7,"%lf,%lf,%lf,%lf,%lf,%lf,%lf", 
             &tmp1,&tmp2,&tmp3,&tmp1,&tmp2,&tmp3,&Rnew);
      XYZ_input(s+7,&XC,&YC,&ZC,&NX,&NY,&NZ,mill_mode);
      if(XC == Xc && YC == Yc && ZC == Zc && 
         NX == Nx && NY == Ny && NZ == Nz && R == Rnew)
      {
         uc4514(chanel_in, s); /* read a next GOTO command */
         XYZ_input(s+5,&XE,&YE,&ZE,&tmp1,&tmp2,&tmp3,mill_mode);
	     new_angle=acos(((XE - Xc)*(*Xe - Xc) + (YE - Yc)*(*Ye - Yc) + (ZE - Zc)*(*Ze - Zc))/(R*R));
		 new_angle=*angle+new_angle;
         circle_unite(Xc,Yc,Zc, Nx,Ny,Nz, R, &XE, &YE, &ZE, &new_angle);
         *Xe=XE; *Ye=YE; *Ze=ZE; *angle=new_angle;
      }
      else uc4535(chanel_in, file_pos);
   }
}
/*- This function compare two coordinat systems -*/

int compare_msys(struct msys m1, struct msys m2)
{
  int i;

  for(i = 0; i < 9; i++) if(m1.p[i] != m2.p[i]) return (0);
  return (1);
}
/*- This function produce an ERROR message delete
   PTP file and stop processing  -*/

void PTP_STOP(char *message)				
{ 
   char command[200];  
  
   uc1601(message, 1);
   uc4540(chanel_out, 0);
   strcat (strcpy(command,"rm "),ptp_file);
   system(command);
}  
/* this function stop  processingan and close PTP file -*/
void PTP_CLOSE(char *message)				
{ 
  uc1601(message, 1);		
  uc4540(chanel_out, 0);
}  
/*- This function look next GOTO unitl END OF PATH
    end calculate the B coordinat in sucesses  
    return 1 in unsucesses  return 0 -*/									
int look_goto(double *b)       																										
{
   int file_pos,rezult;
   char   s[256];
   double x, y, z, i, j, k;
   file_pos = uc4534(chanel_in);
   do
   {
      uc4514(chanel_in, s);
      if(strstr(s, "END OF PATH") != NULL) return (0);
      if(strstr(s, "GOTO/") != NULL)
      {
         rezult = XYZ_input(s+5, &x, &y, &z, &i, &j, &k, mill_mode);
		 if(rezult==6)
		 {
		    *b = b_calculation(i,j,k);
            uc4535(chanel_in,file_pos);
            return (1);
         }
      }
   }while(1);
} 
/* this function reset modality of all coordinat */								
void reset_XYZC()  
{ 
  Xold = Yold = Zold = Cold = -9999999.999;
}

/* correction of C coordinat after using of ROTATE */
double c_correction(double c) 
{
   if(rotate == -999999.999) 
   {
      PTP(" ERROR: No ROTATE command in path with MSYS other then first path");
	  return(c);
   }
   return (c+rotate);
}

/*  This function read X,Y,Z coordinat from CLS file 
    return 3 if read X,Y,Z return 6 if read X,Y,Z,I,J,K
    return 0 in fail to read coordinat  */
int XYZ_input(char *p, double *x, double *y, double *z, 
              double *i, double *j, double *k, int mill_mode) 
{	
   int rezult;
   
   rezult = sscanf(p,"%lf,%lf,%lf,%lf,%lf,%lf",x,y,z,i,j,k); 
   if(mill_mode == -1) PTP(" ERROR: unknown mill_mode in XYZ_input function");
   if(mill_mode) 
   { 
       (*y)=-(*y); 
       (*j)=-(*j); 
   }
   return (rezult);
}

/*- This function read type of cutter compensation -*/
void f_compensation (char *s, int *comp, int *type_of_comp)
{
   char sout[256];
   char sout_1[256];
   *comp = f_cutcom(s);
   if(strstr(s, "OFF"  ) != NULL)                         *comp = 40;
   else if (strstr(s, "LEFT" ) != NULL)                 { *comp = 41;	*type_of_comp=41; } 
   else if (strstr(s, "RIGHT") != NULL)                 { *comp = 42;	*type_of_comp=42; }
   else if (strstr(s, "ON"   ) != NULL && *type_of_comp)  *comp = *type_of_comp;
   else PTP(" ERROR: unknown type of compensatation in CUTCOM/ON command");   
   /* NEXT STRINGS ADD FOR CORRECT VISUALIZATION IN UNISIM */
   /* START */
/*   
   if(mill_mode && Kold == 1)
   { 
      sprintf(sout_1, " G19");
      PTP(sout_1);
   }
   else if(mill_mode && Iold == 1)
   {
      sprintf(sout_1, " G17");
      PTP(sout_1);
   }
*/
   /* END */
   sprintf(sout, " G%d", *comp); PTP(sout);
}

